// ---------------------------------------------------------------------------------------------------------------------------- \\
//															        \\
// File: StringTst.FTH  Author: Oliver SINGLA	 Date: Oct,03,95    Version: 1.00					        \\
// ----		        ------			 ----		    -------						        \\
//															        \\
// Description:	 Test (and show) fixed and dynamic string words.							        \\
//															        \\
// Release:														        \\
//															        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\

( Force decimal for integer numeric I/O )
decimal

( Compiler strategy )
?speed true!						       // Choose speed vs. size
?safe true!						       // Run-time check stack under/overflow
?iarithoverflow true!					       // Run-time check integer arithmetic overflow
?chat true!						       // Print a dot for each compiled definition

( Empty word: this is the 1st word, we kill on each load )
forget <task>
:  <task> ;

( Make SCREEN the context vocabulary )
screen


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : Constant_string											        \\
// 	 Stack : ( --- )												        \\
// Description : This shows how a constant string can be built and used.						        \\
// 															        \\
//    Callers : test													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
: Constant_string
  " A constant string is built with CSTRING\0d\0aExample: \22Hello\22 cstring text\0d\0a" cstring text
  text type
;  // Constant_string


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : test													        \\
// 	 Stack : ( --- )												        \\
// Description : Main word. Show and test string definitions.								        \\
//    Callers : user													        \\
// 	 Calls : Constant_string											        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
: test
  cr
  Constant_string
;  // test

