( Force decimal for integer numeric I/O )
decimal

( Compiler strategy )
?speed.true!						       // Choose speed vs. size
?safe.true!						       // Run-time check stack under/overflow
?iarithoverflow.true!					       // Run-time check integer arithmetic overflow
?chat.true!						       // Print a dot for each compiled definition

( Empty word: this is the 1st word, we kill it on each load )
forget <task>
: <task> ;

// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : WINT													        \\
// 	 Stack : Compile-time: ( --- )		 Input-stream: WINT name						        \\
// 		     Run-time: ( --- addr )										        \\
// Description : As built-in INT, this is defining-word to use 16-bits integer variable.				        \\
//    Callers :													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
:  wint
   build>						       // Define compile-time part:
       1 wallot						       // ( --- addr )  Allocate 16-bits cell
       drop						       // Discard address's cell
   does>						       // Define run-time part:
       ;   // wint


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : BINT													        \\
// 	 Stack : Compile-time: ( --- )		 Input-stream: WINT name						        \\
// 		     Run-time: ( --- addr )										        \\
// Description : As built-in INT, this is defining-word to use 8-bits integer variable.					        \\
//    Callers :													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
:  bint
   build>						       // Define compile-time part:
       1 ballot						       // ( --- addr )  Allocate 8-bits cell
       drop						       // Discard address's cell
   does>						       // Define run-time part:
       ;   // bint


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : DATE													        \\
// 	 Stack : none													        \\
// Description : This is a structure.											        \\
//    Callers :													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
struct DATE
    {
    wint   wYear					       // 1995 for example
    bint   bMonth					       // 1, 2, ... 12
    bint   bDay						       // 1 .. 31
    }


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : DATE.!													        \\
// 	 Stack : ( d m y addr --- )											        \\
// Description : This is a method for DATE structure: initialize a value to a DATE object.				        \\
//    Callers :													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
:  DATE.!
   >R R W.!						       // ( d m y addr --- d m )
   R 2+ B.!						       // ( d m --- d )
   R> 3 + B.!						       // ( d --- )
   ;   // DATE.!


// ---------------------------------------------------------------------------------------------------------------------------- \\
// 	  Word : PERSON													        \\
// 	 Stack : none													        \\
// Description : This is a structure.											        \\
//    Callers :													        \\
// 	 Calls :													        \\
// ---------------------------------------------------------------------------------------------------------------------------- \\
struct PERSON
    {
    24 string   zName					       // Name of the person
    18 string   zFirstname				       // First name of the person
    DATE        sBirthday				       // Birthday for this person
    bint        bAge					       // Computed age of the person
    }

PERSON gsOliver

:   example
    " SINGLA" gsOliver.zName.!
    " Oliver" gsOliver.zFirstname.!
(   1961 gsOliver.sBirthday.wYear.!
       5 gsOliver.sBirthday.bMonth.!
      23 gsOliver.sBirthday.bDay.! )
    23 5 1961 gsOliver.sBirthday.!
    ;  // example

